/*************************************************************
* Include File zum Einbinden der Prototypen fr die Aufrufe an
* die ADwin-Karten.
* Erstellt am : 30.05.2001  M.S.
* gendert am :	12.06.2001  M.S.
				15.05.2002  M.S.
				18.07.2003  M.S.
				24.11.2003  M.S.
				05.05.2004  M.S.
				16.02.2009  M.S.
				08.12.2010  M.S. Comment with default DeviceNo changed.
                14.04.2015  M.S. First code review. Obsolet functions deleted.
				23.04.2015  M.S. Again reworked dipends to ADwin_T.c Version 2.00b9
 Version 2.00   03.07.2015  M.S. Moved the #defines from the ADwin_V2.cpp/ADwin_V2.c files to ADwin_V2.h
 Version 2.01   28.01.2016  M.S. Use the same data type "short" for variable "DataNo".
                                 Changed functions: Data_Length, GetData_String, String_Length, SetData_String
**************************************************************/

#ifndef __adwin_v2_h__
#define __adwin_v2_h__


#ifdef __cplusplus
extern "C" {
#endif  /* __cplusplus */


//Used in function: Data_Length
#define k_Data_not_declared           103	//Data is not declared.

#define k_failed_to_load_DLL_error  50000   //It was not possible to load the adwin32.dll or adwin64.dll
#define k_could_not_find_function   50001   //The called function is not available in the adwin32.dll or adwin64.dll which is used.

//Used in function: Free_Mem
#define k_mem_type_not_supported    50010   //The chosen memory type is not supported by the processor.

//Used in function: Get_Known_DeviceNo
#define k_count_devices_too_small   50020   //Count_Devicesis smaller than the 
										    //current number of configured system.
										    //Count_Devices and Devices are unchanged.

//Used in function: ADwin_Debug_Mode_On
#define k_File_name_too_long		50030   //File name > 255 characters (cannot be processed).
#define k_debug_mode_already_on		50031   //Debug mode already activated (no effect)
#define k_no_permission_on_registry	50032   //Access to the registry is needed, but impossible. Probably
											//the user does not have the necessary administration
											//rights for access or the max. size of the registry is
											//exceeded. Please call your administrator

/* Prototypes of commonly used control functions from the file adwin.c */


#define TYPE_SHORT 1
#define TYPE_LONG 2
#define TYPE_FLOAT 5
#define TYPE_DOUBLE 6

void	Set_Par(short Index, long Value, short DeviceNo, long *ErrorNo);
void	Set_FPar(short Index, float Value, short DeviceNo, long *ErrorNo);
void	Set_FPar_Double (short Index, double Value, short DeviceNo, long *ErrorNo);
long	Get_Par(short Index, short DeviceNo, long *ErrorNo);
float	Get_FPar (short Index, short DeviceNo, long *ErrorNo);
double	Get_FPar_Double (short Index, short DeviceNo, long *ErrorNo);
void	Get_FPar_All_Double (double Array[], short DeviceNo , long *ErrorNo);
void	Get_Par_Block(long Array[], short Startindex, short Count, short DeviceNo,long *ErrorNo);
void	Get_FPar_Block(float Array[], short Startindex, short Count, short DeviceNo , long *ErrorNo);
void	Get_Par_All(long Array[], short DeviceNo,long *ErrorNo);
void	Get_FPar_All(float Array[], short DeviceNo,long *ErrorNo);
void	Set_Processdelay(short ProcessNo, long Processdelay, short DeviceNo , long *ErrorNo);
long	Get_Processdelay(short ProcessNo, short DeviceNo , long *ErrorNo);
void	Get_FPar_Block_Double(double Array[], short Startindex, short Count, short DeviceNo , long *ErrorNo);
long	Process_Status(short ProcessNo, short DeviceNo , long *ErrorNo );

void	Load_Process(char *Filename, short DeviceNo , long *ErrorNo);
void	Start_Process(short ProcessNo, short DeviceNo , long *ErrorNo);
void	Stop_Process(short ProcessNo, short DeviceNo , long *ErrorNo);


void	Boot(char *Filename, short DeviceNo, long *ErrorNo);

void	GetData_Long (short DataNo, long Data[],long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	GetData_Float (short DataNo, float Data[], long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	SetData_Long (short DataNo, long Data[], long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	SetData_Float (short DataNo, float Data[], long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	Data2File(char *Filename, short DataNo, long Startindex, long Count, short Mode, short DeviceNo , long *ErrorNo);
void	File2Data(char *Filename, short DataType, short DataNo, long Startindex, short DeviceNo , long *ErrorNo);
void	GetFifo_Long(short FifoNo, long Data[], long Count, short DeviceNo , long *ErrorNo);
void	GetFifo_Float(short FifoNo, float Data[], long Count, short DeviceNo , long *ErrorNo);
void	SetFifo_Long (short FifoNo, long Data[], long Count, short DeviceNo , long *ErrorNo);
void	SetFifo_Float (short FifoNo, float Data[], long Count, short DeviceNo , long *ErrorNo);
long	Fifo_Full (short FifoNo, short DeviceNo , long *ErrorNo);
long	Fifo_Empty (short FifoNo, short DeviceNo , long *ErrorNo);
void	Fifo_Clear (short FifoNo, short DeviceNo , long *ErrorNo);

void	GetData_Double(short DataNo, double Data[],long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	SetData_Double(short DataNo, double Data[], long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	GetFifo_Double(short FifoNo, double Data[], long Count, short DeviceNo , long *ErrorNo);
void	SetFifo_Double(short FifoNo, double Data[], long Count, short DeviceNo , long *ErrorNo);

void	Clear_Process(short ProcessNo, short DeviceNo , long *ErrorNo);

short	Workload(long Priority, short DeviceNo ,long *ErrorNo);
short	Test_Version(short DeviceNo, long *ErrorNo) ;
long	Free_Mem(short Mem_Spec, short DeviceNo ,long *ErrorNo);
void	Show_Errors(short OnOff);
char	*Get_Error_Text(long ErrorNumber, char *ErrorText , long Length) ;

short	Processor_Type(short DeviceNo,long *ErrorNo);
long	Data_Length(short DataNo, short DeviceNo ,long *ErrorNo);
short   Data_Type(short DataNo, char *TypeName, short DeviceNo ,long *ErrorNo);
void	Set_Language(long language, long *ErrorNo);
long	GetData_String(short DataNo, char *Data, long MaxCount, short DeviceNo ,long *ErrorNo);
long	String_Length(short DataNo, short DeviceNo ,long *ErrorNo);
void	SetData_String(short DataNo, char *Data, short DeviceNo ,long *ErrorNo);
void	Get_Known_DeviceNo(short Devices[], long *Count_Devices, long *ErrorNo);
long	Get_Known_USB_SerialNo(long SerialNo[], long *ErrorNo);
void	ADwin_Debug_Mode_On(char *Filename, long Size, long *ErrorNo);
void	ADwin_Debug_Mode_Off(long *ErrorNo);

// undocumented
void	GetData_Packed_Short(short DataNo, short *Data, long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	GetData_Packed_Long(short DataNo, long *Data, long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	GetData_Packed_Float(short DataNo, float *Data, long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	GetData_Packed_Double(short DataNo, double *Data, long Startindex, long Count, short DeviceNo , long *ErrorNo);
void	GetFifo_Packed_Short(short FifoNo, short Data[], long Count, short DeviceNo , long *ErrorNo);

void	Get_Data_Packed(void *Data, short Typ, short DataNo, long Startindex, long Count, short DeviceNo, long *ErrorNo);
long	Get_Connection_Type(short DeviceNo, long *ErrorNo);

/* 16.04.2015
Important:

If an application program reads the MAC for identifying a special ADwin-system and will refuse operation , if the MAC does not match, then the following issue should be considered :

What if an ADwin-system breaks and needs to be replaced ?

Jaeger Messtechnik will not provide a spare part with an IDENTICAL  MAC address or USB- serialnumber !

The application program has to be prepared somehow, that a replacement with an ADwin-system with a DIFFERENT MAC or USB- serialnumber might be necessary !
*/
void	Get_Dev_ID(long *value, short DeviceNo , long *ErrorNo);



#ifdef __cplusplus
}
#endif

#endif //__adwin_v2_h__
