import QtQuick 2.4
import QtQuick.LocalStorage 2.0
import QtQuick.Controls 2.2
import "database.js" as DataBase

FilterPaneForm {
    property int servoId: 0

    signal coeffsChanged(int servoId)

    function updateFromDB() {
        var filters = DataBase.getFilters()
        sos.txtFM1.text = filters[0].name
        sos.txtFM2.text = filters[1].name
        sos.txtFM3.text = filters[2].name
        sos.txtFM4.text = filters[3].name
        sos.txtFM5.text = filters[4].name

        var rps = [sos.rpFM1, sos.rpFM2, sos.rpFM3, sos.rpFM4, sos.rpFM5];
        for (var i=0; i < DataBase.NUM_SOS; i++) {
            rps[i].itemAt(0).text = filters[i].gain.toFixed(5)
            rps[i].itemAt(1).text = filters[i].C1.toFixed(5)
            rps[i].itemAt(2).text = filters[i].C2.toFixed(5)
            rps[i].itemAt(3).text = filters[i].C3.toFixed(5)
            rps[i].itemAt(4).text = filters[i].C4.toFixed(5)
        }
    }

    function saveToDB() {
        var rps = [sos.rpFM1, sos.rpFM2, sos.rpFM3, sos.rpFM4, sos.rpFM5];
        var names = [sos.txtFM1.text, sos.txtFM2.text, sos.txtFM3.text, sos.txtFM4.text, sos.txtFM5.text];
        for (var i=0; i < DataBase.NUM_SOS; i++) {
            DataBase.saveFilter(i+1, names[i],
                                rps[i].itemAt(0).text,
                                rps[i].itemAt(1).text,
                                rps[i].itemAt(2).text,
                                rps[i].itemAt(3).text,
                                rps[i].itemAt(4).text);
        }
        coeffsChanged(servoId)
    }

    Component.onCompleted: DataBase.initialiseFilterDB()

    onServoIdChanged: updateFromDB()
    btnSaveCoeffs.onClicked: saveToDB()
}
