import QtQuick 2.4
import QtQuick.Controls 2.2

Item {
    id: item1
    width: 750
    height: 600
    property alias sos: sos
    property alias btnSaveCoeffs: btnSaveCoeffs
    property alias servoName: servoName.text

    SecondOrderSection {
        id: sos
        anchors.top: parent.top
        anchors.topMargin: 80
        anchors.right: parent.right
        anchors.rightMargin: 20
        anchors.left: parent.left
        anchors.leftMargin: 20
    }

    Label {
        id: servoName
        text: qsTr("ServoName")
        font.bold: true
        anchors.top: parent.top
        anchors.topMargin: 20
        anchors.left: parent.left
        anchors.leftMargin: 20
        font.pointSize: 12
    }

    Label {
        id: label1
        y: 28
        text: qsTr("Filter Coefficients")
        anchors.bottom: servoName.bottom
        anchors.bottomMargin: 0
        anchors.left: servoName.right
        anchors.leftMargin: 10
        font.pointSize: 12
    }

    Rectangle {
        id: rectangle
        height: 1
        color: "#888888"
        anchors.top: servoName.bottom
        anchors.topMargin: 10
        anchors.right: label1.right
        anchors.rightMargin: 0
        anchors.left: servoName.left
        anchors.leftMargin: 0
        border.color: "#00000000"
    }

    Button {
        id: btnSaveCoeffs
        text: qsTr("Update Coeffs")
        anchors.left: parent.left
        anchors.leftMargin: 20
        anchors.top: sos.bottom
        anchors.topMargin: 20
    }

    Button {
        id: button
        text: qsTr("Load from File")
        anchors.left: btnSaveCoeffs.right
        anchors.leftMargin: 6
        anchors.top: sos.bottom
        anchors.topMargin: 20
    }
}
