import QtQuick 2.7
import QtQuick.Controls 2.2
import QtQuick.Layouts 1.3
import QtQuick.Controls.Material 2.2

Pane {
    width: 650
    property alias rpFM1: rpFM1
    property alias txtFM1: txtFM1
    property alias rpFM2: rpFM2
    property alias txtFM2: txtFM2
    property alias rpFM3: rpFM3
    property alias txtFM3: txtFM3
    property alias rpFM4: rpFM4
    property alias txtFM4: txtFM4
    property alias rpFM5: rpFM5
    property alias txtFM5: txtFM5

    padding: 0
    contentHeight: layout.height
    GridLayout {
        id: layout
        rows: 3
        columns: 6
        anchors {
            left: parent.left
            right: parent.right
        }

        Label {
            text: qsTr("Name")
            horizontalAlignment: Text.AlignHCenter
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Label {
            text: qsTr("Gain")
            horizontalAlignment: Text.AlignHCenter
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Label {
            text: qsTr("C1")
            horizontalAlignment: Text.AlignHCenter
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Label {
            text: qsTr("C2")
            horizontalAlignment: Text.AlignHCenter
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Label {
            text: qsTr("C3")
            horizontalAlignment: Text.AlignHCenter
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Label {
            text: qsTr("C4")
            horizontalAlignment: Text.AlignHCenter
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        // SECOND ORDER SECTION 1
        TextField {
            id: txtFM1
            text: qsTr("FM1")
            font.pointSize: 10
            selectByMouse: true
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Repeater {
            id: rpFM1
            model: 5

            TextField {
                text: qsTr("0.0")
                horizontalAlignment: Text.AlignRight
                font.pointSize: 10
                selectByMouse: true
                Layout.fillHeight: true; Layout.fillWidth: true
                validator: DoubleValidator{}
            }
        }

        // SECOND ORDER SECTION 2
        TextField {
            id: txtFM2
            text: qsTr("FM2")
            font.pointSize: 10
            selectByMouse: true
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Repeater {
            id: rpFM2
            model: 5

            TextField {
                text: qsTr("0.0")
                horizontalAlignment: Text.AlignRight
                font.pointSize: 10
                selectByMouse: true
                Layout.fillHeight: true; Layout.fillWidth: true
                validator: DoubleValidator{}
            }
        }

        // SECOND ORDER SECTION 3
        TextField {
            id: txtFM3
            text: qsTr("FM3")
            font.pointSize: 10
            selectByMouse: true
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Repeater {
            id: rpFM3
            model: 5

            TextField {
                text: qsTr("0.0")
                horizontalAlignment: Text.AlignRight
                font.pointSize: 10
                selectByMouse: true
                Layout.fillHeight: true; Layout.fillWidth: true
                validator: DoubleValidator{}
            }
        }

        // SECOND ORDER SECTION 4
        TextField {
            id: txtFM4
            text: qsTr("FM4")
            font.pointSize: 10
            selectByMouse: true
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Repeater {
            id: rpFM4
            model: 5

            TextField {
                text: qsTr("0.0")
                horizontalAlignment: Text.AlignRight
                font.pointSize: 10
                selectByMouse: true
                Layout.fillHeight: true; Layout.fillWidth: true
                validator: DoubleValidator{}
            }
        }

        // SECOND ORDER SECTION 5
        TextField {
            id: txtFM5
            text: qsTr("FM5")
            font.pointSize: 10
            selectByMouse: true
            Layout.fillHeight: true; Layout.fillWidth: true
        }

        Repeater {
            id: rpFM5
            model: 5

            TextField {
                text: qsTr("0.0")
                horizontalAlignment: Text.AlignRight
                font.pointSize: 10
                selectByMouse: true
                Layout.fillHeight: true; Layout.fillWidth: true
                validator: DoubleValidator{}
            }
        }
    }

}
