import QtQuick 2.7
import QtQuick.Controls 2.2
import QtQuick.Layouts 1.0

Item {
    id: item1
    width: 750
    height: 600
    property alias lblRampFreq: lblRampFreq
    property alias lblRampAmpl: lblRampAmpl
    property alias lblFM4: lblFM4
    property alias lblFM3: lblFM3
    property alias lblFM2: lblFM2
    property alias lblFM5: lblFM5
    property alias lblFM1: lblFM1
    property alias btnOutput: btnOutput
    property alias btnInput: btnInput
    property alias btnOffset: btnOffset
    property alias btnFM5: btnFM5
    property alias btnFM4: btnFM4
    property alias btnFM3: btnFM3
    property alias btnFM2: btnFM2
    property alias btnFM1: btnFM1
    property alias btnAux: btnAux
    property alias btnRamp: btnRamp
    property alias slRampAmpl: slRampAmpl
    property alias slRampFreq: slRampFreq
    property alias txtGain: txtGain
    property alias txtOffset: txtOffset
    property alias txtServoName: txtServoName
    property alias offset: txtOffset.text
    property alias monInput: txtMonInput.text
    property alias monOutput: txtMonOutput.text
    property alias monAux: txtMonAux.text
    property alias gain: txtGain.text
    property alias servoName: txtServoName.text
    property alias rampFreq: slRampFreq.value
    property alias rampAmpl: slRampAmpl.value

    TextField {
        id: txtServoName
        x: 45
        y: 139
        width: 177
        height: 43
        font.bold: true
        anchors.top: parent.top
        anchors.topMargin: 20
        anchors.left: parent.left
        anchors.leftMargin: 20
        selectByMouse: true
    }

    Rectangle {
        id: rectangle
        y: 139
        height: 2
        color: "#000000"
        anchors.right: rectangle2.left
        anchors.rightMargin: -60
        anchors.left: parent.left
        anchors.leftMargin: 25
        z: -3
    }

    Rectangle {
        id: rectangle1
        x: 572
        y: 186
        width: 74
        height: 2
        color: "#000000"
        z: -3
    }

    Rectangle {
        id: rectangle2
        x: 644
        y: 141
        width: 2
        height: 47
        color: "#000000"
        z: -3
    }

    Rectangle {
        id: rectangle3
        x: 640
        y: 135
        width: 10
        height: 10
        color: "#000000"
        radius: 5
    }

    RowLayout {
        y: 116
        width: 730
        height: 48
        spacing: 5
        anchors.left: parent.left
        anchors.leftMargin: 20

        Column {
            Layout.alignment: Qt.AlignLeft | Qt.AlignTop

            Button {
                id: btnInput
                width: 68
                text: qsTr("IN")
                checkable: true
            }

            TextField {
                id: txtMonInput
                width: 68
                height: 41
                text: qsTr("1000")
                enabled: false
                horizontalAlignment: Text.AlignRight
                font.pointSize: 12
            }
        }

        Column {
            Layout.alignment: Qt.AlignLeft | Qt.AlignTop

            Button {
                id: btnOffset
                text: qsTr("Offset")
                highlighted: false
                checkable: true
            }

            TextField {
                id: txtOffset
                width: 68
                height: 41
                text: qsTr("1000")
                horizontalAlignment: Text.AlignRight
                font.pointSize: 12
                selectByMouse: true
                validator: IntValidator {
                    top: 32767
                    bottom: -32768
                }
            }
        }

        Button {
            id: btnFM1
            text: qsTr("FM1")
            Layout.alignment: Qt.AlignLeft | Qt.AlignTop
            Layout.preferredWidth: 48
            checkable: true
            highlighted: false
        }

        Button {
            id: btnFM2
            text: qsTr("FM2")
            Layout.alignment: Qt.AlignLeft | Qt.AlignTop
            Layout.preferredWidth: 48
            checkable: true
            highlighted: false
        }

        Button {
            id: btnFM3
            text: qsTr("FM3")
            Layout.alignment: Qt.AlignLeft | Qt.AlignTop
            Layout.preferredWidth: 48
            checkable: true
            highlighted: false
        }

        Button {
            id: btnFM4
            text: qsTr("FM4")
            Layout.alignment: Qt.AlignLeft | Qt.AlignTop
            Layout.preferredWidth: 48
            checkable: true
            highlighted: false
        }

        Button {
            id: btnFM5
            text: qsTr("FM5")
            Layout.alignment: Qt.AlignLeft | Qt.AlignTop
            Layout.preferredWidth: 48
            checkable: true
            highlighted: false
        }

        Column {
            id: column

            Rectangle {
                id: rectangle4
                width: 78
                height: 47
                radius: 5
                border.width: 2
                border.color: "#000000"
                Label {
                    text: 'x'
                    anchors.verticalCenterOffset: -1
                    anchors.verticalCenter: parent.verticalCenter
                    anchors.left: parent.left
                    anchors.leftMargin: 5
                    font.pointSize: 12
                    color: '#888888'
                }

                TextField {
                    id: txtGain
                    text: qsTr("1.0")
                    anchors.margins: 5
                    anchors.bottomMargin: -3
                    anchors.fill: parent
                    horizontalAlignment: Text.AlignRight
                    font.pointSize: 12
                    selectByMouse: true
                    validator: DoubleValidator {
                        decimals: 3
                    }
                }
            }

            Button {
                id: btnAux
                width: 68
                text: qsTr("AUX")
                anchors.horizontalCenter: parent.horizontalCenter
                checkable: true
            }

            TextField {
                id: txtMonAux
                width: 68
                height: 41
                text: qsTr("1000")
                enabled: false
                anchors.horizontalCenter: parent.horizontalCenter
                horizontalAlignment: Text.AlignRight
                font.pointSize: 12
            }
        }

        Column {
            Layout.alignment: Qt.AlignLeft | Qt.AlignTop

            Button {
                id: btnOutput
                width: 68
                text: qsTr("OUT")
                checkable: true
            }

            TextField {
                id: txtMonOutput
                width: 68
                height: 41
                text: qsTr("1000")
                enabled: false
                horizontalAlignment: Text.AlignRight
                font.pointSize: 12
            }
        }
    }

    Label {
        id: lblFM1
        x: 226
        y: 101
        text: qsTr("Notch 2.1kHz")
        verticalAlignment: Text.AlignBottom
        transformOrigin: Item.TopLeft
        rotation: -45
    }

    Label {
        id: lblFM5
        x: 508
        y: 101
        text: qsTr("LP 10kHz")
        rotation: -45
        verticalAlignment: Text.AlignBottom
        transformOrigin: Item.TopLeft
    }

    Label {
        id: lblFM2
        x: 298
        y: 101
        text: qsTr("Notch 3kHz")
        rotation: -45
        verticalAlignment: Text.AlignBottom
        transformOrigin: Item.TopLeft
    }

    Label {
        id: lblFM3
        x: 364
        y: 101
        text: qsTr("Int 100Hz")
        rotation: -45
        verticalAlignment: Text.AlignBottom
        transformOrigin: Item.TopLeft
    }

    Label {
        id: lblFM4
        x: 436
        y: 101
        text: qsTr("Int 1kHz")
        rotation: -45
        verticalAlignment: Text.AlignBottom
        transformOrigin: Item.TopLeft
    }

    GroupBox {
        id: groupBox
        x: 8
        y: 295
        font.italic: false
        font.bold: false
        title: qsTr("Ramp Generator")
        background: Rectangle {
            color: 'transparent'
        }

        RowLayout {
            spacing: 10

            Button {
                id: btnRamp
                width: 68
                text: qsTr("ON")
                Layout.alignment: Qt.AlignLeft | Qt.AlignTop
                checkable: true
            }

            Column {

                Slider {
                    id: slRampFreq
                    from: 1
                    stepSize: 1
                    to: 255
                    value: 127

                    Label {
                        id: label
                        y: 0
                        text: qsTr("Frequency")
                        anchors.left: parent.left
                        anchors.leftMargin: 0
                    }

                    Label {
                        id: lblRampFreq
                        text: "x Hz"
                        anchors.right: parent.right
                        anchors.rightMargin: 0
                    }
                }

                Slider {
                    id: slRampAmpl
                    value: 0.5

                    Label {
                        id: label1
                        x: 0
                        y: 0
                        text: qsTr("Amplitude")
                    }

                    Label {
                        id: lblRampAmpl
                        text: "x Vpp"
                        anchors.right: parent.right
                        anchors.rightMargin: 0
                    }
                }
            }
        }
    }

    Text {
        id: text1
        y: 548
        text: qsTr("Servo ID:")
        anchors.left: parent.left
        anchors.leftMargin: 20
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 20
        font.pixelSize: 12
    }

    Text {
        id: txtServoId
        y: 565
        text: servoId
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 20
        anchors.left: text1.right
        anchors.leftMargin: 6
        font.pixelSize: 12
    }
}
