var db = LocalStorage.openDatabaseSync("ServoController", "", "ServoDataBase", 1000000);

var NUM_SOS = 5;
/***
* getServo
* retrieve settings for specific servo,
* identified via a
*/
function getServo() {
    console.log("Get Servo..."+servoId);

    var servo = Object({'name': '(Empty Slot)',
                        'gain': 1.0,
                        'offset': 0.0,
                        'switches': 0,
                        'ramp_freq': 10.0,
                        'ramp_ampl': 1.0
                       });
    db.transaction(
        function(tx) {
            var result = tx.executeSql('SELECT * FROM Servos WHERE id=?', servoId);

            if (result.rows.length == 1)
                servo = result.rows.item(0);
            console.log(servo.name);
        }
    )

    return servo;
}

function saveServo() {
    console.log("Saving Servo..."+servoId);

    db.transaction(
        function(tx) {
            tx.executeSql('INSERT OR REPLACE INTO Servos(id, name, switches, offset, gain, ramp_freq, ramp_ampl) \
                           VALUES(?, ?, ?, ?, ?, ?, ?)',
                          [servoId, servoName, switches, offset,
                           gain, rampFreq, rampAmpl])
        }
    )
}

function loadServos() {
    var servos = [];
    var result;
    db.transaction(
        function(tx) {
            tx.executeSql("CREATE TABLE IF NOT EXISTS Servos( \
                                                id INT PRIMARY KEY, \
                                                name TEXT, \
                                                switches INT, \
                                                offset REAL, \
                                                gain REAL, \
                                                ramp_freq REAL, \
                                                ramp_ampl REAL)");

            result = tx.executeSql("SELECT id, name FROM Servos ORDER BY id ASC");
            for (var i = 0; i < result.rows.length; i++)
                servos.push(result.rows.item(i));
        }
    )
    return servos;
}



function initialiseFilterDB() {
    console.log('Filter init')
    db.transaction(
        function(tx) {
            tx.executeSql("CREATE TABLE IF NOT EXISTS Filters( \
                            slot INT, \
                            servo_id INT, \
                            name TEXT, \
                            gain REAL, \
                            C1 REAL, \
                            C2 REAL, \
                            C3 REAL, \
                            C4 REAL, \
                            CONSTRAINT fm_unique UNIQUE(servo_id, slot))");
        }
    )
}

function getFilters() {
    console.log("Getting Filters for Servo..."+servoId);

    var filter_template = Object({'name': '(empty)',
                                  'servo_id': servoId,
                                  'slot': 0,
                                  'gain': 1.0,
                                  'C1': 0.0, 'C2': 0.0, 'C3': 0.0, 'C4': 0.0
                                 });
    var filters = [];
    for (var i = 1; i <= NUM_SOS; i++) {
        var flt = Object.create(filter_template)
        flt.slot = i
        filters.push(flt)
    }
    db.transaction(
        function(tx) {
            var result = tx.executeSql('SELECT * FROM Filters WHERE servo_id=? ORDER BY slot ASC', servoId);
            for (var i = 0; i < result.rows.length; i++) {
                filters[result.rows.item(i).slot-1] = result.rows.item(i);
            }
        }
    )

    return filters;
}

function saveFilter(slot, name, gain, C1, C2, C3, C4) {
    console.log("Saving filter %1, servo %2...".arg(slot).arg(servoId));

    db.transaction(
        function(tx) {
            var result = tx.executeSql('INSERT OR REPLACE INTO Filters \
                                            (name, servo_id, slot, gain, C1, C2, C3, C4) \
                                        VALUES \
                                            (?, ?, ?, ?, ?, ?, ?, ?)',
                                       [name, servoId, slot, gain, C1, C2, C3, C4]);
        }
    )
}
